#include<Servo.h>
#include<Keypad.h>
int key_counter;
bool one_buzz_variable = false;
int servo_position;
bool opening_variable = false;
bool opening_state = false;
unsigned long opening_previous_time;
const unsigned long opening_delay = 5000;
bool keys_stop = false;
bool red_led_blinking_stop = false;
bool red_led_state = false;
unsigned long red_led_previous_time;
const unsigned long red_led_delay = 1000;
bool last_key_pressed_time_stop = false;
unsigned long last_key_pressed_time;
const unsigned long error_delay = 6000;
int buzzer_short_delay_counter;
bool buzzer_short_delay_variable = false;
bool buzzer_short_delay_State = false;
unsigned long buzzer_short_delay_previous_time;
const unsigned long buzzer_short_delay = 100;
int buzzer_long_delay_counter;
bool buzzer_long_delay_variable = false;
bool buzzer_long_delay_State = false;
unsigned long buzzer_long_delay_previous_time;
const unsigned long buzzer_long_delay = 500;
const int buzzer_pin = 13;
const int red_led_pin = 11;
const int green_led_pin = 12;
const byte rows_number = 4; 
const byte columns_number = 4;
char keys_table[rows_number][columns_number] = {
{'1','2','3', 'A'},
{'4','5','6', 'B'},
{'7','8','9', 'C'},
{'*','0','#', 'D'}
};
byte rows_pins[rows_number] = {2, 3, 4, 5};
byte columns_Pins[columns_number] = {6, 7, 8, 9}; 
Servo myservo;
Keypad my_keypad = Keypad( makeKeymap(keys_table), rows_pins, columns_Pins, rows_number, columns_number);
const String master_password = "5079";
String input_password = "";
void setup() {
input_password.reserve(10); 
pinMode(buzzer_pin, OUTPUT);
pinMode(red_led_pin, OUTPUT);
pinMode(green_led_pin, OUTPUT); 
myservo.attach(10); 
myservo.write(0);
}
void red_led_blinking_function()
{
if(millis() - red_led_previous_time >= red_led_delay)
{
red_led_previous_time = millis();
if(red_led_state == false)
red_led_state = true;
else
red_led_state = false; 
digitalWrite(red_led_pin, red_led_state);
}
}
void buzzer_short_delay_function()
{
if(millis() - buzzer_short_delay_previous_time >= buzzer_short_delay)
{
buzzer_short_delay_previous_time = millis();
buzzer_short_delay_counter++;
if(buzzer_short_delay_State == false)
{
buzzer_short_delay_State = true;
} 
else
{
buzzer_short_delay_State = false; 
} 
digitalWrite(buzzer_pin, buzzer_short_delay_State);
}
}
void buzzer_long_delay_function()
{
if(millis() - buzzer_long_delay_previous_time >= buzzer_long_delay)
{
buzzer_long_delay_previous_time = millis();
buzzer_long_delay_counter++;
if(buzzer_long_delay_State == false)
{
buzzer_long_delay_State = true;
} 
else
{
buzzer_long_delay_State = false; 
} 
digitalWrite(buzzer_pin, buzzer_long_delay_State);
}
}
void opening_function()
{
if(millis() - opening_previous_time >= opening_delay)
{
opening_previous_time = millis();
if(opening_state == false)
{
opening_state = true;
servo_position = 90;
red_led_blinking_stop = true;
digitalWrite(red_led_pin, false);
keys_stop = true;
} 
else
{ 
opening_previous_time = (millis() - opening_delay);
servo_position = 0;
opening_state = false; 
red_led_blinking_stop = false;
keys_stop = false;
opening_variable = false; 
} 
digitalWrite(green_led_pin, opening_state);
myservo.write(servo_position);
}
}
void loop() {
char key = my_keypad.getKey();
if(last_key_pressed_time_stop == false)
{
last_key_pressed_time = millis();
} 
if(red_led_blinking_stop == false)
{
red_led_blinking_function();
}
if(opening_variable == true)
{
opening_function();
}
if(buzzer_short_delay_variable == true)
{
buzzer_short_delay_function();
if(buzzer_short_delay_counter == 6)
{
buzzer_short_delay_counter = 0;
buzzer_short_delay_variable = false;
}
}
if(buzzer_long_delay_variable == true)
{
buzzer_long_delay_function();
if(buzzer_long_delay_counter == 2)
{
buzzer_long_delay_counter = 0;
buzzer_long_delay_variable = false;
}
} 
if(one_buzz_variable == true)
{
buzzer_short_delay_function();
if(buzzer_short_delay_counter == 2)
{
buzzer_short_delay_counter = 0;
one_buzz_variable = false;
}
}
if(keys_stop == false)
{ 
if (key)
{
last_key_pressed_time = millis();
last_key_pressed_time_stop = true;
if(key == '*')
{
last_key_pressed_time_stop = false;
key_counter = 0;
buzzer_long_delay_variable = true;
input_password = "";
}
else if (key == '#')
{
last_key_pressed_time_stop = false;
key_counter = 0;
if(input_password == master_password)
{
opening_variable = true;
buzzer_long_delay_variable = true;
}
else
{
buzzer_short_delay_variable = true;
}
input_password = "";
}
else
{
input_password += key;
key_counter++;
if(key_counter < 9)
one_buzz_variable = true;
}
}
} 
if(key_counter == 9)
{
buzzer_short_delay_variable = true;
last_key_pressed_time_stop = false;
key_counter = 0;
input_password = "";
} 
if(millis() - last_key_pressed_time >= error_delay)
{
buzzer_short_delay_variable = true;
last_key_pressed_time_stop = false;
key_counter = 0;
input_password = "";
}
}